mscorlib [00 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00] 1.0.5000.0 2.0.0.0 4.0.0.0 Gtk# is thread aware, but not thread safe; See the <link location="node:gtk-sharp/programming/threads">Gtk# Thread Programming</link> for details. System.ValueType System.Runtime.InteropServices.ComVisible(true)

The class exposes an method that enables you to retrieve the raw RSA key in the form of an structure. Understanding the contents of this structure requires familiarity with how the algorithm works. The next section discusses the algorithm briefly.

## RSA Algorithm

To generate a key pair, you start by creating two large prime numbers named p and q. These numbers are multiplied and the result is called n. Because p and q are both prime numbers, the only factors of n are 1, p, q, and n.

If we consider only numbers that are less than n, the count of numbers that are relatively prime to n, that is, have no factors in common with n, equals (p - 1)(q - 1).

Now you choose a number e, which is relatively prime to the value you calculated. The public key is now represented as {e, n}.

To create the private key, you must calculate d, which is a number such that (d)(e) mod (p - 1)(q - 1) = 1. In accordance with the Euclidean algorithm, the private key is now {d, n}.

Encryption of plaintext m to ciphertext c is defined as c = (m ^ e) mod n. Decryption would then be defined as m = (c ^ d) mod n.

## Summary of Fields

Section A.1.2 of the PKCS #1: RSA Cryptography Standard on the RSA Laboratories Web site defines a format for RSA private keys.

The following table summarizes the fields of the structure. The third column provides the corresponding field in section A.1.2 of PKCS #1: RSA Cryptography Standard.

field

Contains

Corresponding PKCS #1 field

d, the private exponent

privateExponent

d mod (p - 1)

exponent1

d mod (q - 1)

exponent2

e, the public exponent

publicExponent

(InverseQ)(q) = 1 mod p

coefficient

n

modulus

p

prime1

q

prime2

The security of RSA derives from the fact that, given the public key { e, n }, it is computationally infeasible to calculate d, either directly or by factoring n into p and q. Therefore, any part of the key related to d, p, or q must be kept secret. If you call

and ask for only the public key information, this is why you will receive only and . The other fields are available only if you have access to the private key, and you request it.

is not encrypted in any way, so you must be careful when you use it with the private key information. In fact, none of the fields that contain private key information can be serialized. If you try to serialize an structure with a remoting call or by using one of the serializers, you will receive only public key information. If you want to pass private key information, you will have to manually send that data. In all cases, if anyone can derive the parameters, the key that you transmit becomes useless.

Represents the standard parameters for the algorithm.

- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Byte[] To be added

  Represents the D parameter for the algorithm.

- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Byte[] To be added

  Represents the DP parameter for the algorithm.

- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Byte[] To be added

  Represents the DQ parameter for the algorithm.

- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Byte[] To be added

  Represents the Exponent parameter for the algorithm.

- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Byte[] To be added

  Represents the InverseQ parameter for the algorithm.

- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Byte[] To be added

  Represents the Modulus parameter for the algorithm.

- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Byte[] To be added

  Represents the P parameter for the algorithm.

- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Byte[] To be added

  Represents the Q parameter for the algorithm.